/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package openapi

import (
	"time"
)

// ProductRefOrValue - A product to be created defined by value or existing defined by reference. The polymorphic attributes @type, @schemaLocation & @referredType are related to the product entity and not the RelatedProductRefOrValue class itself
type ProductRefOrValue struct {

	// Unique identifier of the product
	Id string `json:"id,omitempty"`

	// Reference of the product
	Href string `json:"href,omitempty"`

	// Is the description of the product. It could be copied from the description of the Product Offering.
	Description string `json:"description,omitempty"`

	// If true, the product is a ProductBundle which is an instantiation of a BundledProductOffering. If false, the product is a ProductComponent which is an instantiation of a SimpleProductOffering.
	IsBundle bool `json:"isBundle,omitempty"`

	// If true, the product is visible by the customer.
	IsCustomerVisible bool `json:"isCustomerVisible,omitempty"`

	// Name of the product. It could be the same as the name of the product offering
	Name string `json:"name,omitempty"`

	// Is the date when the product was ordered
	OrderDate time.Time `json:"orderDate,omitempty"`

	// Is the serial number for the product. This is typically applicable to tangible products e.g. Broadband Router.
	ProductSerialNumber string `json:"productSerialNumber,omitempty"`

	// Is the date from which the product starts
	StartDate time.Time `json:"startDate,omitempty"`

	// Is the date when the product was terminated
	TerminationDate time.Time `json:"terminationDate,omitempty"`

	Agreement []AgreementItemRef `json:"agreement,omitempty"`

	BillingAccount BillingAccountRef `json:"billingAccount,omitempty"`

	Place []RelatedPlaceRefOrValue `json:"place,omitempty"`

	Product []ProductRefOrValue `json:"product,omitempty"`

	ProductCharacteristic []Characteristic `json:"productCharacteristic,omitempty"`

	ProductOffering ProductOfferingRef `json:"productOffering,omitempty"`

	ProductOrderItem []RelatedProductOrderItem `json:"productOrderItem,omitempty"`

	ProductPrice []ProductPrice `json:"productPrice,omitempty"`

	ProductRelationship []ProductRelationship `json:"productRelationship,omitempty"`

	ProductSpecification ProductSpecificationRef `json:"productSpecification,omitempty"`

	ProductTerm []ProductTerm `json:"productTerm,omitempty"`

	RealizingResource []ResourceRef `json:"realizingResource,omitempty"`

	RealizingService []ServiceRef `json:"realizingService,omitempty"`

	RelatedParty []RelatedParty `json:"relatedParty,omitempty"`

	Status ProductStatusType `json:"status,omitempty"`

	// When sub-classing, this defines the super-class
	BaseType string `json:"@baseType,omitempty"`

	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation string `json:"@schemaLocation,omitempty"`

	// When sub-classing, this defines the sub-class entity name
	Type string `json:"@type,omitempty"`

	// The actual type of the target instance when needed for disambiguation.
	ReferredType string `json:"@referredType,omitempty"`
}
